package net.minecraft.client;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.io.File;
import java.nio.ByteBuffer;

import net.minecraft.client.Minecraft.SyntheticClass_1;
import net.minecraft.src.AxisAlignedBB;
import net.minecraft.src.Block;
import net.minecraft.src.ChunkCoordinates;
import net.minecraft.src.ChunkProviderLoadOrGenerate;
import net.minecraft.src.EffectRenderer;
import net.minecraft.src.EntityClientPlayerMP;
import net.minecraft.src.EntityLiving;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.EntityPlayerSP;
import net.minecraft.src.EntityRenderer;
import net.minecraft.src.EnumMovingObjectType;
import net.minecraft.src.EnumOS2;
import net.minecraft.src.EnumOptions;
import net.minecraft.src.FontRenderer;
import net.minecraft.src.GLAllocation;
import net.minecraft.src.GameSettings;
import net.minecraft.src.GameWindowListener;
import net.minecraft.src.GuiChat;
import net.minecraft.src.GuiConflictWarning;
import net.minecraft.src.GuiConnecting;
import net.minecraft.src.GuiGameOver;
import net.minecraft.src.GuiIngame;
import net.minecraft.src.GuiIngameMenu;
import net.minecraft.src.GuiInventory;
import net.minecraft.src.GuiMainMenu;
import net.minecraft.src.GuiScreen;
import net.minecraft.src.GuiSleepMP;
import net.minecraft.src.GuiUnused;
import net.minecraft.src.IChunkProvider;
import net.minecraft.src.ISaveFormat;
import net.minecraft.src.ISaveHandler;
import net.minecraft.src.ItemRenderer;
import net.minecraft.src.ItemStack;
import net.minecraft.src.LoadingScreenRenderer;
import net.minecraft.src.MathHelper;
import net.minecraft.src.MinecraftError;
import net.minecraft.src.MinecraftException;
import net.minecraft.src.MinecraftImpl;
import net.minecraft.src.ModelBiped;
import net.minecraft.src.MouseHelper;
import net.minecraft.src.MovementInputFromOptions;
import net.minecraft.src.MovingObjectPosition;
import net.minecraft.src.NetClientHandler;
import net.minecraft.src.OpenGlCapsChecker;
import net.minecraft.src.PlayerController;
import net.minecraft.src.PlayerControllerTest;
import net.minecraft.src.RenderEngine;
import net.minecraft.src.RenderGlobal;
import net.minecraft.src.RenderManager;
import net.minecraft.src.SaveConverterMcRegion;
import net.minecraft.src.ScaledResolution;
import net.minecraft.src.ScreenShotHelper;
import net.minecraft.src.Session;
import net.minecraft.src.SoundManager;
import net.minecraft.src.Teleporter;
import net.minecraft.src.Tessellator;
import net.minecraft.src.TextureCompassFX;
import net.minecraft.src.TextureFlamesFX;
import net.minecraft.src.TextureLavaFX;
import net.minecraft.src.TextureLavaFlowFX;
import net.minecraft.src.TexturePackList;
import net.minecraft.src.TexturePortalFX;
import net.minecraft.src.TextureWatchFX;
import net.minecraft.src.TextureWaterFX;
import net.minecraft.src.TexureWaterFlowFX;
import net.minecraft.src.ThreadDownloadResources;
import net.minecraft.src.ThreadSleepForever;
import net.minecraft.src.Timer;
import net.minecraft.src.UnexpectedThrowable;
import net.minecraft.src.Vec3D;
import net.minecraft.src.World;
import net.minecraft.src.WorldProvider;
import net.minecraft.src.WorldProviderHell;
import net.minecraft.src.WorldRenderer;

import org.lwjgl.BufferUtils;
import org.lwjgl.LWJGLException;
import org.lwjgl.input.Controllers;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;
import org.lwjgl.opengl.GL12;

public abstract class Minecraft implements Runnable {
	private static Minecraft field_21900_a;
	public PlayerController playerController;
	private boolean fullscreen = false;
	public int displayWidth;
	public int displayHeight;
	private OpenGlCapsChecker glCapabilities;
	private Timer timer = new Timer(20.0F);
	public World theWorld;
	public RenderGlobal renderGlobal;
	public EntityPlayerSP thePlayer;
	public EntityLiving field_22009_h;
	public EffectRenderer effectRenderer;
	public Session session = null;
	public String minecraftUri;
	public Canvas mcCanvas;
	public boolean hideQuitButton = true;
	public volatile boolean isWorldLoaded = false;
	public RenderEngine renderEngine;
	public FontRenderer fontRenderer;
	public GuiScreen currentScreen = null;
	public LoadingScreenRenderer loadingScreen = new LoadingScreenRenderer(this);
	public EntityRenderer entityRenderer = new EntityRenderer(this);
	private ThreadDownloadResources downloadResourcesThread;
	private int ticksRan = 0;
	private int field_6282_S = 0;
	private int field_9236_T;
	private int field_9235_U;
	public GuiIngame ingameGUI;
	public boolean field_6307_v = false;
	public ModelBiped field_9242_w = new ModelBiped(0.0F);
	public MovingObjectPosition objectMouseOver = null;
	public GameSettings gameSettings;
	protected MinecraftApplet mcApplet;
	public SoundManager sndManager = new SoundManager();
	public MouseHelper mouseHelper;
	public TexturePackList texturePackList;
	private File mcDataDir;
	private ISaveFormat field_22008_V;
	public static long[] frameTimes = new long[512];
	public static long[] tickTimes = new long[512];
	public static int numRecordedFrameTimes = 0;
	private String serverName;
	private int serverPort;
	private TextureWaterFX textureWaterFX = new TextureWaterFX();
	private TextureLavaFX textureLavaFX = new TextureLavaFX();
	private static File minecraftDir = null;
	public volatile boolean running = true;
	public String debug = "";
	boolean isTakingScreenshot = false;
	long prevFrameTime = -1L;
	public boolean field_6289_L = false;
	private int field_6302_aa = 0;
	public boolean isRaining = false;
	long systemTime = System.currentTimeMillis();
	private int field_6300_ab = 0;

	public Minecraft(Component component1, Canvas canvas2, MinecraftApplet minecraftApplet3, int i4, int i5, boolean z6) {
		this.field_9235_U = i5;
		this.fullscreen = z6;
		this.mcApplet = minecraftApplet3;
		new ThreadSleepForever(this, "Timer hack thread");
		this.mcCanvas = canvas2;
		this.displayWidth = i4;
		this.displayHeight = i5;
		this.fullscreen = z6;
		if(minecraftApplet3 == null || "true".equals(minecraftApplet3.getParameter("stand-alone"))) {
			this.hideQuitButton = false;
		}

		field_21900_a = this;
	}

	public abstract void displayUnexpectedThrowable(UnexpectedThrowable unexpectedThrowable1);

	public void setServer(String string1, int i2) {
		this.serverName = string1;
		this.serverPort = i2;
	}

	public void startGame() throws LWJGLException {
		if(this.mcCanvas != null) {
			Graphics graphics1 = this.mcCanvas.getGraphics();
			if(graphics1 != null) {
				graphics1.setColor(Color.BLACK);
				graphics1.fillRect(0, 0, this.displayWidth, this.displayHeight);
				graphics1.dispose();
			}

			Display.setParent(this.mcCanvas);
		} else if(this.fullscreen) {
			Display.setFullscreen(true);
			this.displayWidth = Display.getDisplayMode().getWidth();
			this.displayHeight = Display.getDisplayMode().getHeight();
			if(this.displayWidth <= 0) {
				this.displayWidth = 1;
			}

			if(this.displayHeight <= 0) {
				this.displayHeight = 1;
			}
		} else {
			Display.setDisplayMode(new DisplayMode(this.displayWidth, this.displayHeight));
		}

		Display.setTitle("Minecraft Minecraft Beta 1.3_01");

		try {
			Display.create();
		} catch (LWJGLException lWJGLException6) {
			lWJGLException6.printStackTrace();

			try {
				Thread.sleep(1000L);
			} catch (InterruptedException interruptedException5) {
			}

			Display.create();
		}

		RenderManager.instance.itemRenderer = new ItemRenderer(this);
		this.mcDataDir = getMinecraftDir();
		this.field_22008_V = new SaveConverterMcRegion(new File(this.mcDataDir, "saves"));
		this.gameSettings = new GameSettings(this, this.mcDataDir);
		this.texturePackList = new TexturePackList(this, this.mcDataDir);
		this.renderEngine = new RenderEngine(this.texturePackList, this.gameSettings);
		this.fontRenderer = new FontRenderer(this.gameSettings, "/font/default.png", this.renderEngine);
		this.loadScreen();
		Keyboard.create();
		Mouse.create();
		this.mouseHelper = new MouseHelper(this.mcCanvas);

		try {
			Controllers.create();
		} catch (Exception exception4) {
			exception4.printStackTrace();
		}

		this.checkGLError("Pre startup");
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glShadeModel(GL11.GL_SMOOTH);
		GL11.glClearDepth(1.0D);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glDepthFunc(GL11.GL_LEQUAL);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
		GL11.glCullFace(GL11.GL_BACK);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		this.checkGLError("Startup");
		this.glCapabilities = new OpenGlCapsChecker();
		this.sndManager.loadSoundSettings(this.gameSettings);
		this.renderEngine.registerTextureFX(this.textureLavaFX);
		this.renderEngine.registerTextureFX(this.textureWaterFX);
		this.renderEngine.registerTextureFX(new TexturePortalFX());
		this.renderEngine.registerTextureFX(new TextureCompassFX(this));
		this.renderEngine.registerTextureFX(new TextureWatchFX(this));
		this.renderEngine.registerTextureFX(new TexureWaterFlowFX());
		this.renderEngine.registerTextureFX(new TextureLavaFlowFX());
		this.renderEngine.registerTextureFX(new TextureFlamesFX(0));
		this.renderEngine.registerTextureFX(new TextureFlamesFX(1));
		this.renderGlobal = new RenderGlobal(this, this.renderEngine);
		GL11.glViewport(0, 0, this.displayWidth, this.displayHeight);
		this.effectRenderer = new EffectRenderer(this.theWorld, this.renderEngine);

		try {
			this.downloadResourcesThread = new ThreadDownloadResources(this.mcDataDir, this);
			this.downloadResourcesThread.start();
		} catch (Exception exception3) {
		}

		this.checkGLError("Post startup");
		this.ingameGUI = new GuiIngame(this);
		if(this.serverName != null) {
			this.displayGuiScreen(new GuiConnecting(this, this.serverName, this.serverPort));
		} else {
			this.displayGuiScreen(new GuiMainMenu());
		}

	}

	private void loadScreen() throws LWJGLException {
		ScaledResolution scaledResolution1 = new ScaledResolution(this.displayWidth, this.displayHeight);
		int i2 = scaledResolution1.getScaledWidth();
		int i3 = scaledResolution1.getScaledHeight();
		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0D, (double)i2, (double)i3, 0.0D, 1000.0D, 3000.0D);
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();
		GL11.glTranslatef(0.0F, 0.0F, -2000.0F);
		GL11.glViewport(0, 0, this.displayWidth, this.displayHeight);
		GL11.glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
		Tessellator tessellator4 = Tessellator.instance;
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glDisable(GL11.GL_FOG);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/title/mojang.png"));
		tessellator4.startDrawingQuads();
		tessellator4.setColorOpaque_I(0xFFFFFF);
		tessellator4.addVertexWithUV(0.0D, (double)this.displayHeight, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV((double)this.displayWidth, (double)this.displayHeight, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV((double)this.displayWidth, 0.0D, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
		tessellator4.draw();
		short s5 = 256;
		short s6 = 256;
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		tessellator4.setColorOpaque_I(0xFFFFFF);
		this.func_6274_a((this.displayWidth / 2 - s5) / 2, (this.displayHeight / 2 - s6) / 2, 0, 0, s5, s6);
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glDisable(GL11.GL_FOG);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
		Display.swapBuffers();
	}

	public void func_6274_a(int i1, int i2, int i3, int i4, int i5, int i6) {
		float f7 = 0.00390625F;
		float f8 = 0.00390625F;
		Tessellator tessellator9 = Tessellator.instance;
		tessellator9.startDrawingQuads();
		tessellator9.addVertexWithUV((double)(i1 + 0), (double)(i2 + i6), 0.0D, (double)((float)(i3 + 0) * f7), (double)((float)(i4 + i6) * f8));
		tessellator9.addVertexWithUV((double)(i1 + i5), (double)(i2 + i6), 0.0D, (double)((float)(i3 + i5) * f7), (double)((float)(i4 + i6) * f8));
		tessellator9.addVertexWithUV((double)(i1 + i5), (double)(i2 + 0), 0.0D, (double)((float)(i3 + i5) * f7), (double)((float)(i4 + 0) * f8));
		tessellator9.addVertexWithUV((double)(i1 + 0), (double)(i2 + 0), 0.0D, (double)((float)(i3 + 0) * f7), (double)((float)(i4 + 0) * f8));
		tessellator9.draw();
	}

	public static File getMinecraftDir() {
		if(minecraftDir == null) {
			minecraftDir = getAppDir("minecraft");
		}

		return minecraftDir;
	}

	public static File getAppDir(String string0) {
		String string1 = System.getProperty("user.home", ".");
		File file2;
		switch(SyntheticClass_1.$SwitchMap$net$minecraft$src$EnumOS2[getOs().ordinal()]) {
		case 1:
		case 2:
			file2 = new File(string1, '.' + string0 + '/');
			break;
		case 3:
			String string3 = System.getenv("APPDATA");
			if(string3 != null) {
				file2 = new File(string3, "." + string0 + '/');
			} else {
				file2 = new File(string1, '.' + string0 + '/');
			}
			break;
		case 4:
			file2 = new File(string1, "Library/Application Support/" + string0);
			break;
		default:
			file2 = new File(string1, string0 + '/');
		}

		if(!file2.exists() && !file2.mkdirs()) {
			throw new RuntimeException("The working directory could not be created: " + file2);
		} else {
			return file2;
		}
	}

	private static EnumOS2 getOs() {
		String string0 = System.getProperty("os.name").toLowerCase();
		return string0.contains("win") ? EnumOS2.c : (string0.contains("mac") ? EnumOS2.d : (string0.contains("solaris") ? EnumOS2.b : (string0.contains("sunos") ? EnumOS2.b : (string0.contains("linux") ? EnumOS2.a : (string0.contains("unix") ? EnumOS2.a : EnumOS2.e)))));
	}

	public ISaveFormat func_22004_c() {
		return this.field_22008_V;
	}

	public void displayGuiScreen(GuiScreen guiScreen1) {
		if(!(this.currentScreen instanceof GuiUnused)) {
			if(this.currentScreen != null) {
				this.currentScreen.onGuiClosed();
			}

			if(guiScreen1 == null && this.theWorld == null) {
				guiScreen1 = new GuiMainMenu();
			} else if(guiScreen1 == null && this.thePlayer.health <= 0) {
				guiScreen1 = new GuiGameOver();
			}

			this.currentScreen = (GuiScreen)guiScreen1;
			if(guiScreen1 != null) {
				this.func_6273_f();
				ScaledResolution scaledResolution2 = new ScaledResolution(this.displayWidth, this.displayHeight);
				int i3 = scaledResolution2.getScaledWidth();
				int i4 = scaledResolution2.getScaledHeight();
				((GuiScreen)guiScreen1).setWorldAndResolution(this, i3, i4);
				this.field_6307_v = false;
			} else {
				this.func_6259_e();
			}
		}

	}

	private void checkGLError(String string1) {
		int i2 = GL11.glGetError();
		if(i2 != 0) {
			String string3 = GLU.gluErrorString(i2);
			System.out.println("########## GL ERROR ##########");
			System.out.println("@ " + string1);
			System.out.println(i2 + ": " + string3);
			System.exit(0);
		}

	}

	public void shutdownMinecraftApplet() {
		if(this.mcApplet != null) {
			this.mcApplet.clearApplet();
		}

		try {
			if(this.downloadResourcesThread != null) {
				this.downloadResourcesThread.closeMinecraft();
			}
		} catch (Exception exception10) {
		}

		try {
			System.out.println("Stopping!");

			try {
				this.changeWorld1((World)null);
			} catch (Throwable throwable8) {
			}

			try {
				GLAllocation.deleteTexturesAndDisplayLists();
			} catch (Throwable throwable7) {
			}

			this.sndManager.closeMinecraft();
			Mouse.destroy();
			Keyboard.destroy();
		} finally {
			Display.destroy();
			System.exit(0);
		}

		System.gc();
	}

	public void run() {
		this.running = true;

		try {
			this.startGame();
		} catch (Exception exception15) {
			exception15.printStackTrace();
			this.displayUnexpectedThrowable(new UnexpectedThrowable("Failed to start game", exception15));
			return;
		}

		try {
			long j1 = System.currentTimeMillis();
			int i3 = 0;

			while(this.running && (this.mcApplet == null || this.mcApplet.isActive())) {
				AxisAlignedBB.clearBoundingBoxPool();
				Vec3D.initialize();
				if(this.mcCanvas == null && Display.isCloseRequested()) {
					this.shutdown();
				}

				if(this.isWorldLoaded && this.theWorld != null) {
					float f4 = this.timer.renderPartialTicks;
					this.timer.updateTimer();
					this.timer.renderPartialTicks = f4;
				} else {
					this.timer.updateTimer();
				}

				long j19 = System.nanoTime();

				for(int i6 = 0; i6 < this.timer.elapsedTicks; ++i6) {
					++this.ticksRan;

					try {
						this.runTick();
					} catch (MinecraftException minecraftException14) {
						this.theWorld = null;
						this.changeWorld1((World)null);
						this.displayGuiScreen(new GuiConflictWarning());
					}
				}

				long j20 = System.nanoTime() - j19;
				this.checkGLError("Pre render");
				this.sndManager.func_338_a(this.thePlayer, this.timer.renderPartialTicks);
				GL11.glEnable(GL11.GL_TEXTURE_2D);
				if(this.theWorld != null && !this.theWorld.multiplayerWorld) {
					this.theWorld.func_6465_g();
				}

				if(this.theWorld != null && this.theWorld.multiplayerWorld) {
					this.theWorld.func_6465_g();
				}

				if(this.gameSettings.limitFramerate) {
					Thread.sleep(5L);
				}

				if(!Keyboard.isKeyDown(Keyboard.KEY_F7)) {
					Display.update();
				}

				if(!this.field_6307_v) {
					if(this.playerController != null) {
						this.playerController.setPartialTime(this.timer.renderPartialTicks);
					}

					this.entityRenderer.func_4136_b(this.timer.renderPartialTicks);
				}

				if(!Display.isActive()) {
					if(this.fullscreen) {
						this.toggleFullscreen();
					}

					Thread.sleep(10L);
				}

				if(this.gameSettings.showDebugInfo) {
					this.displayDebugInfo(j20);
				} else {
					this.prevFrameTime = System.nanoTime();
				}

				Thread.yield();
				if(Keyboard.isKeyDown(Keyboard.KEY_F7)) {
					Display.update();
				}

				this.screenshotListener();
				if(this.mcCanvas != null && !this.fullscreen && (this.mcCanvas.getWidth() != this.displayWidth || this.mcCanvas.getHeight() != this.displayHeight)) {
					this.displayWidth = this.mcCanvas.getWidth();
					this.displayHeight = this.mcCanvas.getHeight();
					if(this.displayWidth <= 0) {
						this.displayWidth = 1;
					}

					if(this.displayHeight <= 0) {
						this.displayHeight = 1;
					}

					this.resize(this.displayWidth, this.displayHeight);
				}

				this.checkGLError("Post render");
				++i3;

				for(this.isWorldLoaded = !this.isMultiplayerWorld() && this.currentScreen != null && this.currentScreen.doesGuiPauseGame(); System.currentTimeMillis() >= j1 + 1000L; i3 = 0) {
					this.debug = i3 + " fps, " + WorldRenderer.chunksUpdated + " chunk updates";
					WorldRenderer.chunksUpdated = 0;
					j1 += 1000L;
				}
			}
		} catch (MinecraftError minecraftError16) {
		} catch (Throwable throwable17) {
			this.theWorld = null;
			throwable17.printStackTrace();
			this.displayUnexpectedThrowable(new UnexpectedThrowable("Unexpected error", throwable17));
		} finally {
			this.shutdownMinecraftApplet();
		}

	}

	private void screenshotListener() {
		if(Keyboard.isKeyDown(this.gameSettings.keyBindScreenshot.keyCode)) {
			if(!this.isTakingScreenshot) {
				this.isTakingScreenshot = true;
				this.ingameGUI.addChatMessage(ScreenShotHelper.saveScreenshot(minecraftDir, this.displayWidth, this.displayHeight));
			}
		} else {
			this.isTakingScreenshot = false;
		}

	}

	private String func_21001_a(File file1, int i2, int i3, int i4, int i5) {
		try {
			ByteBuffer byteBuffer6 = BufferUtils.createByteBuffer(i2 * i3 * 3);
			ScreenShotHelper screenShotHelper7 = new ScreenShotHelper(file1, i4, i5, i3);
			double d8 = (double)i4 / (double)i2;
			double d10 = (double)i5 / (double)i3;
			double d12 = d8 > d10 ? d8 : d10;

			for(int i14 = (i5 - 1) / i3 * i3; i14 >= 0; i14 -= i3) {
				for(int i15 = 0; i15 < i4; i15 += i2) {
					GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/terrain.png"));
					double d16 = (double)(i4 - i2) / 2.0D * 2.0D - (double)(i15 * 2);
					double d18 = (double)(i5 - i3) / 2.0D * 2.0D - (double)(i14 * 2);
					d16 /= (double)i2;
					d18 /= (double)i3;
					this.entityRenderer.func_21152_a(d12, d16, d18);
					this.entityRenderer.renderWorld(1.0F);
					this.entityRenderer.func_21151_b();
					Display.update();

					try {
						Thread.sleep(10L);
					} catch (InterruptedException interruptedException21) {
						interruptedException21.printStackTrace();
					}

					Display.update();
					byteBuffer6.clear();
					GL11.glPixelStorei(GL11.GL_PACK_ALIGNMENT, 1);
					GL11.glPixelStorei(GL11.GL_UNPACK_ALIGNMENT, 1);
					GL11.glReadPixels(0, 0, i2, i3, GL12.GL_BGR, GL11.GL_UNSIGNED_BYTE, byteBuffer6);
					screenShotHelper7.func_21189_a(byteBuffer6, i15, i14, i2, i3);
				}

				screenShotHelper7.func_21191_a();
			}

			return screenShotHelper7.func_21190_b();
		} catch (Exception exception22) {
			exception22.printStackTrace();
			return "Failed to save image: " + exception22;
		}
	}

	private void displayDebugInfo(long j1) {
		long j3 = 16666666L;
		if(this.prevFrameTime == -1L) {
			this.prevFrameTime = System.nanoTime();
		}

		long j5 = System.nanoTime();
		tickTimes[numRecordedFrameTimes & frameTimes.length - 1] = j1;
		frameTimes[numRecordedFrameTimes++ & frameTimes.length - 1] = j5 - this.prevFrameTime;
		this.prevFrameTime = j5;
		GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0D, (double)this.displayWidth, (double)this.displayHeight, 0.0D, 1000.0D, 3000.0D);
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();
		GL11.glTranslatef(0.0F, 0.0F, -2000.0F);
		GL11.glLineWidth(1.0F);
		GL11.glDisable(GL11.GL_TEXTURE_2D);
		Tessellator tessellator7 = Tessellator.instance;
		tessellator7.startDrawing(7);
		int i8 = (int)(j3 / 200000L);
		tessellator7.setColorOpaque_I(536870912);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex(0.0D, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.setColorOpaque_I(0x20200000);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8 * 2), 0.0D);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)(this.displayHeight - i8 * 2), 0.0D);
		tessellator7.draw();
		long j9 = 0L;

		int i11;
		for(i11 = 0; i11 < frameTimes.length; ++i11) {
			j9 += frameTimes[i11];
		}

		i11 = (int)(j9 / 200000L / (long)frameTimes.length);
		tessellator7.startDrawing(7);
		tessellator7.setColorOpaque_I(0x20400000);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i11), 0.0D);
		tessellator7.addVertex(0.0D, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)frameTimes.length, (double)(this.displayHeight - i11), 0.0D);
		tessellator7.draw();
		tessellator7.startDrawing(1);

		for(int i12 = 0; i12 < frameTimes.length; ++i12) {
			int i13 = (i12 - numRecordedFrameTimes & frameTimes.length - 1) * 255 / frameTimes.length;
			int i14 = i13 * i13 / 255;
			i14 = i14 * i14 / 255;
			int i15 = i14 * i14 / 255;
			i15 = i15 * i15 / 255;
			if(frameTimes[i12] > j3) {
				tessellator7.setColorOpaque_I(0xFF000000 + i14 * 65536);
			} else {
				tessellator7.setColorOpaque_I(0xFF000000 + i14 * 256);
			}

			long j16 = frameTimes[i12] / 200000L;
			long j18 = tickTimes[i12] / 200000L;
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - j16) + 0.5F), 0.0D);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)this.displayHeight + 0.5F), 0.0D);
			tessellator7.setColorOpaque_I(0xFF000000 + i14 * 65536 + i14 * 256 + i14 * 1);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - j16) + 0.5F), 0.0D);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - (j16 - j18)) + 0.5F), 0.0D);
		}

		tessellator7.draw();
		GL11.glEnable(GL11.GL_TEXTURE_2D);
	}

	public void shutdown() {
		this.running = false;
	}

	public void func_6259_e() {
		if(Display.isActive() && !this.field_6289_L) {
			this.field_6289_L = true;
			this.mouseHelper.func_774_a();
			this.displayGuiScreen((GuiScreen)null);
			this.field_6302_aa = this.ticksRan + 10000;
		}

	}

	public void func_6273_f() {
		if(this.field_6289_L) {
			if(this.thePlayer != null) {
				this.thePlayer.resetPlayerKeyState();
			}

			this.field_6289_L = false;
			this.mouseHelper.func_773_b();
		}

	}

	public void func_6252_g() {
		if(this.currentScreen == null) {
			this.displayGuiScreen(new GuiIngameMenu());
		}

	}

	private void func_6254_a(int i1, boolean z2) {
		if(!this.playerController.field_1064_b && (i1 != 0 || this.field_6282_S <= 0)) {
			if(z2 && this.objectMouseOver != null && this.objectMouseOver.typeOfHit == EnumMovingObjectType.TILE && i1 == 0) {
				int i3 = this.objectMouseOver.blockX;
				int i4 = this.objectMouseOver.blockY;
				int i5 = this.objectMouseOver.blockZ;
				this.playerController.sendBlockRemoving(i3, i4, i5, this.objectMouseOver.sideHit);
				this.effectRenderer.addBlockHitEffects(i3, i4, i5, this.objectMouseOver.sideHit);
			} else {
				this.playerController.func_6468_a();
			}
		}

	}

	private void clickMouse(int i1) {
		if(i1 != 0 || this.field_6282_S <= 0) {
			if(i1 == 0) {
				this.thePlayer.swingItem();
			}

			boolean z2 = true;
			if(this.objectMouseOver == null) {
				if(i1 == 0 && !(this.playerController instanceof PlayerControllerTest)) {
					this.field_6282_S = 10;
				}
			} else if(this.objectMouseOver.typeOfHit == EnumMovingObjectType.ENTITY) {
				if(i1 == 0) {
					this.playerController.func_6472_b(this.thePlayer, this.objectMouseOver.entityHit);
				}

				if(i1 == 1) {
					this.playerController.func_6475_a(this.thePlayer, this.objectMouseOver.entityHit);
				}
			} else if(this.objectMouseOver.typeOfHit == EnumMovingObjectType.TILE) {
				int i3 = this.objectMouseOver.blockX;
				int i4 = this.objectMouseOver.blockY;
				int i5 = this.objectMouseOver.blockZ;
				int i6 = this.objectMouseOver.sideHit;
				Block block7 = Block.blocksList[this.theWorld.getBlockId(i3, i4, i5)];
				if(i1 == 0) {
					this.theWorld.onBlockHit(i3, i4, i5, this.objectMouseOver.sideHit);
					if(block7 != Block.bedrock || this.thePlayer.field_9371_f >= 100) {
						this.playerController.clickBlock(i3, i4, i5, this.objectMouseOver.sideHit);
					}
				} else {
					ItemStack itemStack8 = this.thePlayer.inventory.getCurrentItem();
					int i9 = itemStack8 != null ? itemStack8.stackSize : 0;
					if(this.playerController.sendPlaceBlock(this.thePlayer, this.theWorld, itemStack8, i3, i4, i5, i6)) {
						z2 = false;
						this.thePlayer.swingItem();
					}

					if(itemStack8 == null) {
						return;
					}

					if(itemStack8.stackSize == 0) {
						this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
					} else if(itemStack8.stackSize != i9) {
						this.entityRenderer.itemRenderer.func_9449_b();
					}
				}
			}

			if(z2 && i1 == 1) {
				ItemStack itemStack10 = this.thePlayer.inventory.getCurrentItem();
				if(itemStack10 != null && this.playerController.sendUseItem(this.thePlayer, this.theWorld, itemStack10)) {
					this.entityRenderer.itemRenderer.func_9450_c();
				}
			}
		}

	}

	public void toggleFullscreen() {
		try {
			this.fullscreen = !this.fullscreen;
			System.out.println("Toggle fullscreen!");
			if(this.fullscreen) {
				Display.setDisplayMode(Display.getDesktopDisplayMode());
				this.displayWidth = Display.getDisplayMode().getWidth();
				this.displayHeight = Display.getDisplayMode().getHeight();
				if(this.displayWidth <= 0) {
					this.displayWidth = 1;
				}

				if(this.displayHeight <= 0) {
					this.displayHeight = 1;
				}
			} else {
				if(this.mcCanvas != null) {
					this.displayWidth = this.mcCanvas.getWidth();
					this.displayHeight = this.mcCanvas.getHeight();
				} else {
					this.displayWidth = this.field_9236_T;
					this.displayHeight = this.field_9235_U;
				}

				if(this.displayWidth <= 0) {
					this.displayWidth = 1;
				}

				if(this.displayHeight <= 0) {
					this.displayHeight = 1;
				}

				Display.setDisplayMode(new DisplayMode(this.field_9236_T, this.field_9235_U));
			}

			this.func_6273_f();
			Display.setFullscreen(this.fullscreen);
			Display.update();
			Thread.sleep(1000L);
			if(this.fullscreen) {
				this.func_6259_e();
			}

			if(this.currentScreen != null) {
				this.func_6273_f();
				this.resize(this.displayWidth, this.displayHeight);
			}

			System.out.println("Size: " + this.displayWidth + ", " + this.displayHeight);
		} catch (Exception exception2) {
			exception2.printStackTrace();
		}

	}

	private void resize(int i1, int i2) {
		if(i1 <= 0) {
			i1 = 1;
		}

		if(i2 <= 0) {
			i2 = 1;
		}

		this.displayWidth = i1;
		this.displayHeight = i2;
		if(this.currentScreen != null) {
			ScaledResolution scaledResolution3 = new ScaledResolution(i1, i2);
			int i4 = scaledResolution3.getScaledWidth();
			int i5 = scaledResolution3.getScaledHeight();
			this.currentScreen.setWorldAndResolution(this, i4, i5);
		}

	}

	private void clickMiddleMouseButton() {
		if(this.objectMouseOver != null) {
			int i1 = this.theWorld.getBlockId(this.objectMouseOver.blockX, this.objectMouseOver.blockY, this.objectMouseOver.blockZ);
			if(i1 == Block.grass.blockID) {
				i1 = Block.dirt.blockID;
			}

			if(i1 == Block.stairDouble.blockID) {
				i1 = Block.stairSingle.blockID;
			}

			if(i1 == Block.bedrock.blockID) {
				i1 = Block.stone.blockID;
			}

			this.thePlayer.inventory.setCurrentItem(i1, this.playerController instanceof PlayerControllerTest);
		}

	}

	public void runTick() {
		this.ingameGUI.updateTick();
		this.entityRenderer.getMouseOver(1.0F);
		int i1;
		int i4;
		if(this.thePlayer != null) {
			IChunkProvider iChunkProvider2 = this.theWorld.func_21118_q();
			if(iChunkProvider2 instanceof ChunkProviderLoadOrGenerate) {
				ChunkProviderLoadOrGenerate chunkProviderLoadOrGenerate3 = (ChunkProviderLoadOrGenerate)iChunkProvider2;
				i1 = MathHelper.floor_float((float)((int)this.thePlayer.posX)) >> 4;
				i4 = MathHelper.floor_float((float)((int)this.thePlayer.posZ)) >> 4;
				chunkProviderLoadOrGenerate3.func_21110_c(i1, i4);
			}
		}

		if(!this.isWorldLoaded && this.theWorld != null) {
			this.playerController.updateController();
		}

		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/terrain.png"));
		if(!this.isWorldLoaded) {
			this.renderEngine.func_1067_a();
		}

		if(this.currentScreen == null && this.thePlayer != null) {
			if(this.thePlayer.health <= 0) {
				this.displayGuiScreen((GuiScreen)null);
			} else if(this.thePlayer.isPlayerSleeping() && this.theWorld != null && this.theWorld.multiplayerWorld) {
				this.displayGuiScreen(new GuiSleepMP());
			}
		} else if(this.currentScreen != null && this.currentScreen instanceof GuiSleepMP && !this.thePlayer.isPlayerSleeping()) {
			this.displayGuiScreen((GuiScreen)null);
		}

		if(this.currentScreen != null) {
			this.field_6302_aa = this.ticksRan + 10000;
		}

		if(this.currentScreen != null) {
			this.currentScreen.handleInput();
			if(this.currentScreen != null) {
				this.currentScreen.updateScreen();
			}
		}

		if(this.currentScreen == null || this.currentScreen.field_948_f) {
			label294:
			while(true) {
				while(true) {
					while(true) {
						long j5;
						do {
							if(!Mouse.next()) {
								if(this.field_6282_S > 0) {
									--this.field_6282_S;
								}

								while(true) {
									while(true) {
										do {
											if(!Keyboard.next()) {
												if(this.currentScreen == null) {
													if(Mouse.isButtonDown(0) && (float)(this.ticksRan - this.field_6302_aa) >= this.timer.ticksPerSecond / 4.0F && this.field_6289_L) {
														this.clickMouse(0);
														this.field_6302_aa = this.ticksRan;
													}

													if(Mouse.isButtonDown(1) && (float)(this.ticksRan - this.field_6302_aa) >= this.timer.ticksPerSecond / 4.0F && this.field_6289_L) {
														this.clickMouse(1);
														this.field_6302_aa = this.ticksRan;
													}
												}

												this.func_6254_a(0, this.currentScreen == null && Mouse.isButtonDown(0) && this.field_6289_L);
												break label294;
											}

											this.thePlayer.handleKeyPress(Keyboard.getEventKey(), Keyboard.getEventKeyState());
										} while(!Keyboard.getEventKeyState());

										if(Keyboard.getEventKey() == Keyboard.KEY_F11) {
											this.toggleFullscreen();
										} else {
											if(this.currentScreen != null) {
												this.currentScreen.handleKeyboardInput();
											} else {
												if(Keyboard.getEventKey() == Keyboard.KEY_ESCAPE) {
													this.func_6252_g();
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_S && Keyboard.isKeyDown(Keyboard.KEY_F3)) {
													this.forceReload();
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_F1) {
													this.gameSettings.field_22277_y = !this.gameSettings.field_22277_y;
												}

												if(Keyboard.getEventKey() == this.gameSettings.keyBindDebug.keyCode) {
													this.gameSettings.showDebugInfo = !this.gameSettings.showDebugInfo;
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_F5) {
													this.gameSettings.thirdPersonView = !this.gameSettings.thirdPersonView;
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_F8) {
													this.gameSettings.field_22274_D = !this.gameSettings.field_22274_D;
												}

												if(Keyboard.getEventKey() == this.gameSettings.keyBindInventory.keyCode) {
													this.displayGuiScreen(new GuiInventory(this.thePlayer));
												}

												if(Keyboard.getEventKey() == this.gameSettings.keyBindDrop.keyCode) {
													this.thePlayer.dropCurrentItem();
												}

												if(this.isMultiplayerWorld() && Keyboard.getEventKey() == this.gameSettings.keyBindChat.keyCode) {
													this.displayGuiScreen(new GuiChat());
												}
											}

											for(i4 = 0; i4 < 9; ++i4) {
												if(Keyboard.getEventKey() == Keyboard.KEY_1 + i4) {
													this.thePlayer.inventory.currentItem = i4;
												}
											}

											if(Keyboard.getEventKey() == this.gameSettings.keyBindToggleFog.keyCode) {
												this.gameSettings.setOptionValue(EnumOptions.RENDER_DISTANCE, !Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) && !Keyboard.isKeyDown(Keyboard.KEY_RSHIFT) ? 1 : -1);
											}
										}
									}
								}
							}

							j5 = System.currentTimeMillis() - this.systemTime;
						} while(j5 > 200L);

						i1 = Mouse.getEventDWheel();
						if(i1 != 0) {
							this.thePlayer.inventory.changeCurrentItem(i1);
							if(this.gameSettings.field_22275_C) {
								if(i1 > 0) {
									i1 = 1;
								}

								if(i1 < 0) {
									i1 = -1;
								}

								this.gameSettings.field_22272_F += (float)i1 * 0.25F;
							}
						}

						if(this.currentScreen == null) {
							if(!this.field_6289_L && Mouse.getEventButtonState()) {
								this.func_6259_e();
							} else {
								if(Mouse.getEventButton() == 0 && Mouse.getEventButtonState()) {
									this.clickMouse(0);
									this.field_6302_aa = this.ticksRan;
								}

								if(Mouse.getEventButton() == 1 && Mouse.getEventButtonState()) {
									this.clickMouse(1);
									this.field_6302_aa = this.ticksRan;
								}

								if(Mouse.getEventButton() == 2 && Mouse.getEventButtonState()) {
									this.clickMiddleMouseButton();
								}
							}
						} else if(this.currentScreen != null) {
							this.currentScreen.handleMouseInput();
						}
					}
				}
			}
		}

		if(this.theWorld != null) {
			if(this.thePlayer != null) {
				++this.field_6300_ab;
				if(this.field_6300_ab == 30) {
					this.field_6300_ab = 0;
					this.theWorld.joinEntityInSurroundings(this.thePlayer);
				}
			}

			this.theWorld.difficultySetting = this.gameSettings.difficulty;
			if(this.theWorld.multiplayerWorld) {
				this.theWorld.difficultySetting = 3;
			}

			if(!this.isWorldLoaded) {
				this.entityRenderer.updateRenderer();
			}

			if(!this.isWorldLoaded) {
				this.renderGlobal.func_945_d();
			}

			if(!this.isWorldLoaded) {
				this.theWorld.func_633_c();
			}

			if(!this.isWorldLoaded || this.isMultiplayerWorld()) {
				this.theWorld.func_21114_a(this.gameSettings.difficulty > 0, true);
				this.theWorld.tick();
			}

			if(!this.isWorldLoaded && this.theWorld != null) {
				this.theWorld.randomDisplayUpdates(MathHelper.floor_double(this.thePlayer.posX), MathHelper.floor_double(this.thePlayer.posY), MathHelper.floor_double(this.thePlayer.posZ));
			}

			if(!this.isWorldLoaded) {
				this.effectRenderer.updateEffects();
			}
		}

		this.systemTime = System.currentTimeMillis();
	}

	private void forceReload() {
		System.out.println("FORCING RELOAD!");
		this.sndManager = new SoundManager();
		this.sndManager.loadSoundSettings(this.gameSettings);
		this.downloadResourcesThread.reloadResources();
	}

	public boolean isMultiplayerWorld() {
		return this.theWorld != null && this.theWorld.multiplayerWorld;
	}

	public void startWorld(String string1, String string2, long j3) {
		this.changeWorld1((World)null);
		System.gc();
		if(this.field_22008_V.func_22175_a(string1)) {
			this.func_22002_b(string1, string2);
		} else {
			ISaveHandler iSaveHandler5 = this.field_22008_V.func_22174_a(string1, false);
			World world6 = new World(iSaveHandler5, string2, j3);
			if(world6.isNewWorld) {
				this.changeWorld2(world6, "Generating level");
			} else {
				this.changeWorld2(world6, "Loading level");
			}
		}

	}

	public void usePortal() {
		if(this.thePlayer.dimension == -1) {
			this.thePlayer.dimension = 0;
		} else {
			this.thePlayer.dimension = -1;
		}

		this.theWorld.setEntityDead(this.thePlayer);
		this.thePlayer.isDead = false;
		double d1 = this.thePlayer.posX;
		double d3 = this.thePlayer.posZ;
		double d5 = 8.0D;
		World world7;
		if(this.thePlayer.dimension == -1) {
			d1 /= d5;
			d3 /= d5;
			this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
			this.theWorld.updateEntityWithOptionalForce(this.thePlayer, false);
			world7 = new World(this.theWorld, new WorldProviderHell());
			this.changeWorld(world7, "Entering the Nether", this.thePlayer);
		} else {
			d1 *= d5;
			d3 *= d5;
			this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
			this.theWorld.updateEntityWithOptionalForce(this.thePlayer, false);
			world7 = new World(this.theWorld, new WorldProvider());
			this.changeWorld(world7, "Leaving the Nether", this.thePlayer);
		}

		this.thePlayer.worldObj = this.theWorld;
		this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
		this.theWorld.updateEntityWithOptionalForce(this.thePlayer, false);
		(new Teleporter()).func_4107_a(this.theWorld, this.thePlayer);
	}

	public void changeWorld1(World world1) {
		this.changeWorld2(world1, "");
	}

	public void changeWorld2(World world1, String string2) {
		this.changeWorld(world1, string2, (EntityPlayer)null);
	}

	public void changeWorld(World world1, String string2, EntityPlayer entityPlayer3) {
		this.field_22009_h = null;
		this.loadingScreen.printText(string2);
		this.loadingScreen.displayLoadingString("");
		this.sndManager.func_331_a((String)null, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F);
		if(this.theWorld != null) {
			this.theWorld.func_651_a(this.loadingScreen);
		}

		this.theWorld = world1;
		if(world1 != null) {
			this.playerController.func_717_a(world1);
			if(!this.isMultiplayerWorld()) {
				if(entityPlayer3 == null) {
					this.thePlayer = (EntityPlayerSP)world1.func_4085_a(EntityPlayerSP.class);
				}
			} else if(this.thePlayer != null) {
				this.thePlayer.preparePlayerToSpawn();
				if(world1 != null) {
					world1.entityJoinedWorld(this.thePlayer);
				}
			}

			if(!world1.multiplayerWorld) {
				this.func_6255_d(string2);
			}

			if(this.thePlayer == null) {
				this.thePlayer = (EntityPlayerSP)this.playerController.func_4087_b(world1);
				this.thePlayer.preparePlayerToSpawn();
				this.playerController.flipPlayer(this.thePlayer);
			}

			this.thePlayer.movementInput = new MovementInputFromOptions(this.gameSettings);
			if(this.renderGlobal != null) {
				this.renderGlobal.func_946_a(world1);
			}

			if(this.effectRenderer != null) {
				this.effectRenderer.clearEffects(world1);
			}

			this.playerController.func_6473_b(this.thePlayer);
			if(entityPlayer3 != null) {
				world1.func_6464_c();
			}

			IChunkProvider iChunkProvider4 = world1.func_21118_q();
			if(iChunkProvider4 instanceof ChunkProviderLoadOrGenerate) {
				ChunkProviderLoadOrGenerate chunkProviderLoadOrGenerate5 = (ChunkProviderLoadOrGenerate)iChunkProvider4;
				int i6 = MathHelper.floor_float((float)((int)this.thePlayer.posX)) >> 4;
				int i7 = MathHelper.floor_float((float)((int)this.thePlayer.posZ)) >> 4;
				chunkProviderLoadOrGenerate5.func_21110_c(i6, i7);
			}

			world1.spawnPlayerWithLoadedChunks(this.thePlayer);
			if(world1.isNewWorld) {
				world1.func_651_a(this.loadingScreen);
			}

			this.field_22009_h = this.thePlayer;
		} else {
			this.thePlayer = null;
		}

		System.gc();
		this.systemTime = 0L;
	}

	private void func_22002_b(String string1, String string2) {
		this.loadingScreen.printText("Converting World to " + this.field_22008_V.func_22178_a());
		this.loadingScreen.displayLoadingString("This may take a while :)");
		this.field_22008_V.func_22171_a(string1, this.loadingScreen);
		this.startWorld(string1, string2, 0L);
	}

	private void func_6255_d(String string1) {
		this.loadingScreen.printText(string1);
		this.loadingScreen.displayLoadingString("Building terrain");
		short s2 = 128;
		int i3 = 0;
		int i4 = s2 * 2 / 16 + 1;
		i4 *= i4;
		IChunkProvider iChunkProvider5 = this.theWorld.func_21118_q();
		ChunkCoordinates chunkCoordinates6 = this.theWorld.func_22137_s();
		if(this.thePlayer != null) {
			chunkCoordinates6.field_22395_a = (int)this.thePlayer.posX;
			chunkCoordinates6.field_22396_c = (int)this.thePlayer.posZ;
		}

		if(iChunkProvider5 instanceof ChunkProviderLoadOrGenerate) {
			ChunkProviderLoadOrGenerate chunkProviderLoadOrGenerate7 = (ChunkProviderLoadOrGenerate)iChunkProvider5;
			chunkProviderLoadOrGenerate7.func_21110_c(chunkCoordinates6.field_22395_a >> 4, chunkCoordinates6.field_22396_c >> 4);
		}

		for(int i9 = -s2; i9 <= s2; i9 += 16) {
			for(int i8 = -s2; i8 <= s2; i8 += 16) {
				this.loadingScreen.setLoadingProgress(i3++ * 100 / i4);
				this.theWorld.getBlockId(chunkCoordinates6.field_22395_a + i9, 64, chunkCoordinates6.field_22396_c + i8);

				while(this.theWorld.func_6465_g()) {
				}
			}
		}

		this.loadingScreen.displayLoadingString("Simulating world for a bit");
		boolean z10 = true;
		this.theWorld.func_656_j();
	}

	public void installResource(String string1, File file2) {
		int i3 = string1.indexOf("/");
		String string4 = string1.substring(0, i3);
		string1 = string1.substring(i3 + 1);
		if(string4.equalsIgnoreCase("sound")) {
			this.sndManager.addSound(string1, file2);
		} else if(string4.equalsIgnoreCase("newsound")) {
			this.sndManager.addSound(string1, file2);
		} else if(string4.equalsIgnoreCase("streaming")) {
			this.sndManager.addStreaming(string1, file2);
		} else if(string4.equalsIgnoreCase("music")) {
			this.sndManager.addMusic(string1, file2);
		} else if(string4.equalsIgnoreCase("newmusic")) {
			this.sndManager.addMusic(string1, file2);
		}

	}

	public OpenGlCapsChecker func_6251_l() {
		return this.glCapabilities;
	}

	public String func_6241_m() {
		return this.renderGlobal.func_953_b();
	}

	public String func_6262_n() {
		return this.renderGlobal.func_957_c();
	}

	public String func_21002_o() {
		return this.theWorld.func_21119_g();
	}

	public String func_6245_o() {
		FontRenderer fontRenderer1 = this.fontRenderer;
		fontRenderer1.drawStringWithShadow("Particles: ", 2, 82, 16579668);
		fontRenderer1.drawStringWithShadow("" + this.effectRenderer.getStatistics(), 2 + fontRenderer1.getStringWidth("Particles: "), 82, 5569788);
		fontRenderer1.drawStringWithShadow("Total Entities: ", 2, 92, 16579668);
		fontRenderer1.drawStringWithShadow("" + this.theWorld.func_687_d(), 2 + fontRenderer1.getStringWidth("Total Entities: "), 92, 5569788);
		return "";
	}

	public void respawn() {
		if(!this.theWorld.worldProvider.canRespawnHere()) {
			this.usePortal();
		}

		ChunkCoordinates chunkCoordinates1 = this.theWorld.func_22137_s();
		IChunkProvider iChunkProvider2 = this.theWorld.func_21118_q();
		if(iChunkProvider2 instanceof ChunkProviderLoadOrGenerate) {
			ChunkProviderLoadOrGenerate chunkProviderLoadOrGenerate3 = (ChunkProviderLoadOrGenerate)iChunkProvider2;
			chunkProviderLoadOrGenerate3.func_21110_c(chunkCoordinates1.field_22395_a >> 4, chunkCoordinates1.field_22396_c >> 4);
		}

		this.theWorld.setSpawnLocation();
		this.theWorld.updateEntityList();
		int i4 = 0;
		if(this.thePlayer != null) {
			i4 = this.thePlayer.entityId;
			this.theWorld.setEntityDead(this.thePlayer);
		}

		this.field_22009_h = null;
		this.thePlayer = (EntityPlayerSP)this.playerController.func_4087_b(this.theWorld);
		this.field_22009_h = this.thePlayer;
		this.thePlayer.preparePlayerToSpawn();
		this.playerController.flipPlayer(this.thePlayer);
		this.theWorld.spawnPlayerWithLoadedChunks(this.thePlayer);
		this.thePlayer.movementInput = new MovementInputFromOptions(this.gameSettings);
		this.thePlayer.entityId = i4;
		this.thePlayer.func_6420_o();
		this.playerController.func_6473_b(this.thePlayer);
		this.func_6255_d("Respawning");
		if(this.currentScreen instanceof GuiGameOver) {
			this.displayGuiScreen((GuiScreen)null);
		}

	}

	public static void func_6269_a(String string0, String string1) {
		startMainThread(string0, string1, (String)null);
	}

	public static void startMainThread(String string0, String string1, String string2) {
		boolean z3 = false;
		Frame frame4 = new Frame("Minecraft");
		Canvas canvas5 = new Canvas();
		frame4.setLayout(new BorderLayout());
		frame4.add(canvas5, "Center");
		canvas5.setPreferredSize(new Dimension(854, 480));
		frame4.pack();
		frame4.setLocationRelativeTo((Component)null);
		MinecraftImpl minecraftImpl6 = new MinecraftImpl(frame4, canvas5, (MinecraftApplet)null, 854, 480, z3, frame4);
		Thread thread7 = new Thread(minecraftImpl6, "Minecraft main thread");
		thread7.setPriority(10);
		minecraftImpl6.minecraftUri = "www.minecraft.net";
		if(string0 != null && string1 != null) {
			minecraftImpl6.session = new Session(string0, string1);
		} else {
			minecraftImpl6.session = new Session("Player" + System.currentTimeMillis() % 1000L, "");
		}

		if(string2 != null) {
			String[] string8 = string2.split(":");
			minecraftImpl6.setServer(string8[0], Integer.parseInt(string8[1]));
		}

		frame4.setVisible(true);
		frame4.addWindowListener(new GameWindowListener(minecraftImpl6, thread7));
		thread7.start();
	}

	public NetClientHandler func_20001_q() {
		return this.thePlayer instanceof EntityClientPlayerMP ? ((EntityClientPlayerMP)this.thePlayer).sendQueue : null;
	}

	public static void main(String[] string0) {
		String string1 = "Player" + System.currentTimeMillis() % 1000L;
		if(string0.length > 0) {
			string1 = string0[0];
		}

		String string2 = "-";
		if(string0.length > 1) {
			string2 = string0[1];
		}

		func_6269_a(string1, string2);
	}

	public static boolean func_22006_t() {
		return field_21900_a == null || !field_21900_a.gameSettings.field_22277_y;
	}

	public static boolean func_22001_u() {
		return field_21900_a != null && field_21900_a.gameSettings.fancyGraphics;
	}

	public static boolean func_22005_v() {
		return field_21900_a != null && field_21900_a.gameSettings.field_22278_j;
	}

	public static boolean func_22007_w() {
		return field_21900_a != null && field_21900_a.gameSettings.showDebugInfo;
	}

	public boolean func_22003_b(String string1) {
		if(string1.startsWith("/")) {
			;
		}

		return false;
	}
	
	static final class SyntheticClass_1 {
		public static final int[] $SwitchMap$net$minecraft$src$EnumOS2 = new int[EnumOS2.values().length];

		static {
			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.a.ordinal()] = 1;
			} catch (NoSuchFieldError noSuchFieldError4) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.b.ordinal()] = 2;
			} catch (NoSuchFieldError noSuchFieldError3) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.c.ordinal()] = 3;
			} catch (NoSuchFieldError noSuchFieldError2) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.d.ordinal()] = 4;
			} catch (NoSuchFieldError noSuchFieldError1) {
			}

		}
	}
}
