package net.minecraft.src;

import java.util.List;

public class WorldInfo {
	private long randomSeed;
	public int spawnX;
	public int spawnY;
	public int spawnZ;
	private long worldTime;
	private long field_22315_f;
	private long sizeOnDisk;
	private NBTTagCompound field_22313_h;
	private int field_22312_i;
	private String levelName;
	private int saveVersion;

	public WorldInfo(NBTTagCompound nBTTagCompound1) {
		this.randomSeed = nBTTagCompound1.getLong("RandomSeed");
		this.spawnX = nBTTagCompound1.getInteger("SpawnX");
		this.spawnY = nBTTagCompound1.getInteger("SpawnY");
		this.spawnZ = nBTTagCompound1.getInteger("SpawnZ");
		this.worldTime = nBTTagCompound1.getLong("Time");
		this.field_22315_f = nBTTagCompound1.getLong("LastPlayed");
		this.sizeOnDisk = nBTTagCompound1.getLong("SizeOnDisk");
		this.levelName = nBTTagCompound1.getString("LevelName");
		this.saveVersion = nBTTagCompound1.getInteger("version");
		if(nBTTagCompound1.hasKey("Player")) {
			this.field_22313_h = nBTTagCompound1.getCompoundTag("Player");
			this.field_22312_i = this.field_22313_h.getInteger("Dimension");
		}

	}

	public WorldInfo(long j1, String string3) {
		this.randomSeed = j1;
		this.levelName = string3;
	}

	public WorldInfo(WorldInfo worldInfo1) {
		this.randomSeed = worldInfo1.randomSeed;
		this.spawnX = worldInfo1.spawnX;
		this.spawnY = worldInfo1.spawnY;
		this.spawnZ = worldInfo1.spawnZ;
		this.worldTime = worldInfo1.worldTime;
		this.field_22315_f = worldInfo1.field_22315_f;
		this.sizeOnDisk = worldInfo1.sizeOnDisk;
		this.field_22313_h = worldInfo1.field_22313_h;
		this.field_22312_i = worldInfo1.field_22312_i;
		this.levelName = worldInfo1.levelName;
		this.saveVersion = worldInfo1.saveVersion;
	}

	public NBTTagCompound func_22299_a() {
		NBTTagCompound nBTTagCompound1 = new NBTTagCompound();
		this.func_22291_a(nBTTagCompound1, this.field_22313_h);
		return nBTTagCompound1;
	}

	public NBTTagCompound func_22305_a(List list1) {
		NBTTagCompound nBTTagCompound2 = new NBTTagCompound();
		EntityPlayer entityPlayer3 = null;
		NBTTagCompound nBTTagCompound4 = null;
		if(list1.size() > 0) {
			entityPlayer3 = (EntityPlayer)list1.get(0);
		}

		if(entityPlayer3 != null) {
			nBTTagCompound4 = new NBTTagCompound();
			entityPlayer3.writeToNBT(nBTTagCompound4);
		}

		this.func_22291_a(nBTTagCompound2, nBTTagCompound4);
		return nBTTagCompound2;
	}

	private void func_22291_a(NBTTagCompound nBTTagCompound1, NBTTagCompound nBTTagCompound2) {
		nBTTagCompound1.setLong("RandomSeed", this.randomSeed);
		nBTTagCompound1.setInteger("SpawnX", this.spawnX);
		nBTTagCompound1.setInteger("SpawnY", this.spawnY);
		nBTTagCompound1.setInteger("SpawnZ", this.spawnZ);
		nBTTagCompound1.setLong("Time", this.worldTime);
		nBTTagCompound1.setLong("SizeOnDisk", this.sizeOnDisk);
		nBTTagCompound1.setLong("LastPlayed", System.currentTimeMillis());
		nBTTagCompound1.setString("LevelName", this.levelName);
		nBTTagCompound1.setInteger("version", this.saveVersion);
		if(nBTTagCompound2 != null) {
			nBTTagCompound1.setCompoundTag("Player", nBTTagCompound2);
		}

	}

	public long getRandomSeed() {
		return this.randomSeed;
	}

	public int func_22293_c() {
		return this.spawnX;
	}

	public int func_22295_d() {
		return this.spawnY;
	}

	public int func_22300_e() {
		return this.spawnZ;
	}

	public long getWorldTime() {
		return this.worldTime;
	}

	public long func_22306_g() {
		return this.sizeOnDisk;
	}

	public NBTTagCompound func_22303_h() {
		return this.field_22313_h;
	}

	public int func_22290_i() {
		return this.field_22312_i;
	}

	public void func_22294_a(int i1) {
		this.spawnX = i1;
	}

	public void func_22308_b(int i1) {
		this.spawnY = i1;
	}

	public void func_22298_c(int i1) {
		this.spawnZ = i1;
	}

	public void setWorldTime(long j1) {
		this.worldTime = j1;
	}

	public void func_22297_b(long j1) {
		this.sizeOnDisk = j1;
	}

	public void func_22309_a(NBTTagCompound nBTTagCompound1) {
		this.field_22313_h = nBTTagCompound1;
	}

	public void func_22292_a(int i1, int i2, int i3) {
		this.spawnX = i1;
		this.spawnY = i2;
		this.spawnZ = i3;
	}

	public String getWorldName() {
		return this.levelName;
	}

	public void func_22287_a(String string1) {
		this.levelName = string1;
	}

	public int func_22296_k() {
		return this.saveVersion;
	}

	public void func_22289_d(int i1) {
		this.saveVersion = i1;
	}

	public long func_22301_l() {
		return this.field_22315_f;
	}
}
